module KW_Functions
module Material_Selection
	UI.menu("Plugins").add_item("Material Selection") do
		select_materials
	end
	
	def self.select_materials
		model = Sketchup.active_model
		materials = model.materials
		m = materials.current
		s = model.selection
		s.clear
		recurse(model.active_entities, m, s)

	end
	
	def self.recurse(ents, m, s)
		ents.each do |e|
			if e.is_a? Sketchup::Group
				unless e.material == nil
					if e.material == m
						s.add e
					end
				end
				recurse(e.entities, m, s)
			elsif e.is_a? Sketchup::ComponentInstance
				unless e.material == nil
					if e.material == m
						s.add e
					end
				end
				recurse(e.definition.entities, m, s)
			elsif e.material == m
				s.add e
			end
		end
	end
	
end

module Hide_All

	UI.menu("Plugins").add_item("Hide All Un-Selected") do
		Sketchup.active_model.start_operation("Hide All Unselected")
		hide_all_unselected
		Sketchup.active_model.commit_operation
	end
	
	def self.hide_all_unselected
		KW_Functions.invert_selection(Sketchup.active_model.selection, Sketchup.active_model.active_entities, [], false)
		hide_all
	end
	
	def self.hide_all
		
		sel = Sketchup.active_model.selection
		sel.each do |s|
			s.visible = false
		end
		
	end
end

def self.invert_selection(s, ents, comps, bool)
	new_ents = []
	ents.each do |e|
		if e.is_a? Sketchup::Group
			new_ents += e.entities.to_a
			invert(s, e) if bool == true
		elsif e.is_a? Sketchup::ComponentInstance
			invert(s, e) if bool == true
			if !comps.include?(e.definition)
				new_ents += e.definition.entities.to_a
				comps << e.definition
			end
		else
			invert(s,e)
		end
	end
	invert_selection(s, new_ents, comps, bool) if new_ents.length > 0
end

def self.invert(s, e)
	if s.contains? e
		s.remove e
	else
		s.add e
	end
end
end

